"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.expressionPart = void 0;
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
class expressionPart {
    constructor() {
    }
    get subParts() {
        return new List_1.default();
    }
    resolveClass(expressionData, resolved, targetType, running, evaluateAllContexts = true, setValue) {
        if (targetType != undefined) {
            let result = this.resolve(expressionData, resolved, running, evaluateAllContexts, setValue);
            return result;
            //return typeMapper.toType(result as Object, targetType);
        }
        else {
            return this.resolve(expressionData, resolved, undefined, evaluateAllContexts, setValue);
        }
    }
    resolveGeneric(expressionData, resolved, tType, running, evaluateAllContexts = true, setValue = undefined) {
        if (running == undefined) {
            let result = this.resolveClass(expressionData, resolved, tType, running, evaluateAllContexts, setValue);
            return result;
        }
        else {
            return this.resolveGeneric(expressionData, resolved, tType, undefined, evaluateAllContexts, setValue);
        }
    }
}
exports.expressionPart = expressionPart;
//# sourceMappingURL=expressionPart.js.map