"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sum = void 0;
const aggregateFunction_1 = require("./../aggregateFunction");
const general_1 = require("../../utils/general");
class sum extends aggregateFunction_1.aggregateFunction {
    invokeIteration(expressionData, current, running, parameters, /* out */ resolved) {
        resolved.resolved = true;
        if ((current != null)) {
            if ((typeof current == 'string')) {
                return (Number.parseFloat(current)) + (running != null ? running : 0);
            }
            else if (typeof current == 'boolean') {
                return (((current) ? 1 : 0) + ((running != null ? (running ? 1 : 0) : 0))) > 0 ? true : false;
            }
            // else if ((current instanceof  byte)) {
            //     return ((<number>(current)) + (<number>(running)));
            //     // TODO: Warning!!!, inline IF is not supported ?
            //     (running != null);
            //     0;
            // }
            else if (typeof current == 'number' && !general_1.isFloatType(current)) {
                return (current) + (running != null ? running : 0);
            }
            else if (typeof current == 'number' && general_1.isFloatType(current)) {
                return (current) + (running != null ? running : 0);
            }
        }
        return running != null ? running : 0;
    }
}
exports.sum = sum;
//# sourceMappingURL=sum.js.map