﻿import { aggregateFunction } from './../aggregateFunction'
import expressionData from '../../expressionData'
import { expressionPart } from './../../compiler/parts/expressionPart'
import { List } from 'typescript-dotnet-commonjs/System/Collections/List'
import { } from "typescript-dotnet-commonjs/System/Text/Utility"
import { format } from 'util'
import { outputVariables } from '../../utils/outputVariables';

export class groupConcat extends aggregateFunction {

    public /* internal */ /* override */ invokeIteration(expressionData: expressionData, current: Object, running: Object, parameters: List<expressionPart>, /* out */resolved: outputVariables): Object {
        let delimit: string = "";
        let delimiterResolved: outputVariables = new outputVariables();
        delimiterResolved.resolved = false;
        if (((parameters != null)
            && (parameters.count > 0))) {

            delimit = String.StringFormat("{0}", parameters.get(0).resolve(expressionData, /* out */delimiterResolved, /* running:*/ undefined) as string);
        }

        resolved.resolved = true;

        return running != null ? String.StringFormat("{0}{1}{2}", running.toString(), delimit, current.toString()) : String.StringFormat("{0}", current.toString());

    }
}