﻿import {iTypeMapper} from './iTypeMapper';
import {defaultTypeMapper} from './defaultTypeMapper';

    export class typeMapperRegistry {
        
        public static currentTypeMapper: any = new defaultTypeMapper();
        
        public static get CurrentTypeMapper(): iTypeMapper {
            return typeMapperRegistry.currentTypeMapper;
        }
        public static set CurrentTypeMapper(value: iTypeMapper)  {
            typeMapperRegistry.currentTypeMapper = value;
        }
        
        public static registerTypeMapper(typeMapper: iTypeMapper): boolean {
            if ((typeMapper != null)) {
                typeMapperRegistry.currentTypeMapper = typeMapper;
                return true;
            }
            
            return false;
        }
    }