"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.literalPart = void 0;
const Utility_1 = require("typescript-dotnet-commonjs/System/Text/Utility");
const expressionPart_1 = require("./expressionPart");
class literalPart extends expressionPart_1.expressionPart {
    // public get simpleName(): string {
    //     throw new Error("Method not implemented.");
    // }
    constructor() {
        super();
    }
    get value() {
        return this._value;
    }
    set value(value) {
        this._value = value;
    }
    get simpleName() {
        return "Item";
    }
    resolve(expressionData, /* out */ resolved, running, evaluateAllContexts = true, setValue = undefined) {
        resolved.resolved = true;
        return this._value;
    }
    toString() {
        if ((typeof this._value == 'string' && this._value.length === 1)) {
            return Utility_1.format("'{0}'", this._value);
        }
        else if ((typeof this._value == 'string')) {
            return Utility_1.format("\"{0}\"", this._value);
        }
        return Utility_1.format("{0}", this._value);
    }
}
exports.literalPart = literalPart;
//# sourceMappingURL=literalPart.js.map