"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sortParameterPart = void 0;
const expressionPart_1 = require("./expressionPart");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
class sortParameterPart extends expressionPart_1.expressionPart {
    constructor() {
        super(...arguments);
        this.ascending = true;
    }
    get simpleName() {
        return "Sort";
    }
    get subParts() {
        return (new List_1.default()).add(this.expression);
    }
    resolve(expressionData, /* out */ resolved, running, evaluateAllContexts = true, setValue = undefined) {
        return this.expression.resolve(expressionData, /* out */ resolved, running, evaluateAllContexts, setValue);
    }
}
exports.sortParameterPart = sortParameterPart;
//# sourceMappingURL=sortParameterPart.js.map