"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.min = void 0;
const aggregateFunction_1 = require("./../aggregateFunction");
class min extends aggregateFunction_1.aggregateFunction {
    invokeIteration(expressionData, current, running, parameters, /* out */ resolved) {
        resolved.resolved = true;
        if (current != null && running != null && (typeof current == 'object')) {
            if (current.compareTo(running) < 0) {
                return current;
            }
            else {
                return running;
            }
        }
        return current;
    }
}
exports.min = min;
//# sourceMappingURL=min.js.map