"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepCopy = exports.Stack = void 0;
class Stack {
    constructor() {
        this._store = [];
        this._store = [];
    }
    contains(currentContext) {
        return this._store.includes(currentContext);
    }
    count() {
        return this._store.length;
    }
    isEmpty() {
        return this._store.length === 0;
    }
    clear() {
        this._store = [];
    }
    peek() {
        let d = this.clone();
        return d.pop();
    }
    push(val) {
        this._store.push(val);
    }
    pop() {
        return this._store.pop();
    }
    clone() {
        let copiedStack = new Stack();
        this._store.forEach((element) => {
            copiedStack.push(element);
        });
        return copiedStack;
    }
}
exports.Stack = Stack;
class Node {
    constructor(data, previous) {
        this.previous = previous;
        this.data = data;
    }
}
exports.deepCopy = (target) => {
    if (target === null) {
        return target;
    }
    if (target instanceof Date) {
        return new Date(target.getTime());
    }
    if (target instanceof Array) {
        const cp = [];
        target.forEach((v) => { cp.push(v); });
        return cp.map((n) => exports.deepCopy(n));
    }
    if (typeof target === 'object' && target !== {}) {
        const cp = Object.assign({}, target);
        Object.keys(cp).forEach(k => {
            cp[k] = exports.deepCopy(cp[k]);
        });
        return cp;
    }
    return target;
};
//# sourceMappingURL=stack.js.map