﻿import expressionData from "../../expressionData";
import { expressionPart } from "./expressionPart";
import { groupDataContext } from "../../functions/groupDataContext";
import { outputVariables } from "../../utils/outputVariables";


export class indicatorPart extends expressionPart {
    _value: string="";

    public get simpleName(): string {
        return "Indicator";
    }

    public get value(): string{
        return this._value;
    }
    public set value(value){
        this.value= value;
    }

    resolve(expressionData: expressionData, /* out */resolved: outputVariables, running: groupDataContext, evaluateAllContexts: boolean = true, setValue: Object | undefined = undefined): Object {
        resolved.resolved = true;
        return ("#" + this._value);
    }
}
