﻿import { literalPart } from './literalPart';
import { format } from "typescript-dotnet-commonjs/System/Text/Utility";
import { expressionPart } from './expressionPart';
import expressionData from '../../expressionData';
import { groupDataContext } from '../../functions/groupDataContext';
import { typeMapper } from './../../types/typeMapper';
import IEnumerable from 'typescript-dotnet-commonjs/System/Collections/Enumeration/IEnumerable';
import List from 'typescript-dotnet-commonjs/System/Collections/List';
import { getType } from '../../utils/reflectionExtender';
import { Type } from 'typescript';

export class nullPart extends literalPart {

    public constructor()
    {
        super();
    }
    public toString(): string {
        return "null";
    }
}
