﻿import {aggregateFunction} from './../aggregateFunction'
import expressionData from '../../expressionData'
import {expressionPart} from './../../compiler/parts/expressionPart'
import { List} from  'typescript-dotnet-commonjs/System/Collections/List'
import { IComparable} from 'typescript-dotnet-commonjs/System/IComparable';
import { outputVariables } from '../../utils/outputVariables';

export class min extends aggregateFunction {
        
        public /* internal */ /* override */ invokeIteration(expressionData: expressionData, current: Object, running: Object, parameters: List<expressionPart>, /* out */resolved: outputVariables): Object {
            resolved.resolved = true;
            if(current != null && running != null && (typeof current == 'object')) {
                if ((current as IComparable<any>).compareTo(running) < 0) {
                    return current;
                }
                else {
                    return running;
                }
            }
            
            return current;
        }
}